 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin
;	jr $
	ld a,$47:call fila
 ld a,$10;,bc,$7FFD:out (c),a
 call bank02
 ld hl,out_spr
 ld de,$4800
 ld c,29
olp1:
 push de
 ld b,16
olp2:
 ld (hl),$e1:inc hl
 ld (hl),$22:inc hl
 ld (hl),e:inc hl
 ld (hl),d:inc hl
 
 push de
 call nbde
 ld (hl),$22:inc hl
 ld (hl),e:inc hl
 ld (hl),d:inc hl
 pop de
 
 
 inc de,de
 djnz olp2
 pop de
 call nbde
 call nbde
 dec c:jr nz,olp1
 ld de,back
 ld (hl),$C3:inc hl
 ld (hl),e:inc hl
 ld (hl),d:inc hl

test:
 ei:halt;:halt:halt
 ld (back+1),sp
 ld sp,$A000
 jp out_spr
back: ld sp,0
; ld a,7:out ($FE),a
cntr:ld a,0
  ld l,a,h,0
  add hl,hl
 ld de,frames
 add hl,de
 ld a,(hl):inc hl:ld h,(hl),l,a
 ld de,$A000
 call dzx7_standard
 
delay:ld a,0
 inc a:cp 3:jr nz,no_too_late
 ld a,(cntr+1)
 inc a
 ld (cntr+1),a
 xor a
no_too_late:
 ld (delay+1),a

 ld a,(cntr+1)
 cp 141
 jp nz, test
;draw logo
	ld hl,$5900
	ld de,lgo
	ld a,4
lg2:
	exa
	ld ix,cols
lg3: ld b,128
lg1:
	ld a,(de)
	and b
	jr z,putc
	ld a,(ix)
putc:
	ld (hl),a
	inc hl
	inc ix
	srl b
	jr nc,lg1
	inc de
	ld a,l
	and 31
	jr nz,lg3
	exa
	dec a
	jr nz,lg2


wp:	ld hl,(intcnt)
	ld de,$02b8
	or a:sbc hl,de
	jr c,wp
	
	ld hl,$5900,de,$5901,bc,255,(hl),l:ldir
;draw square
;------------------------------------------------------------------------------
square:
 ld ix, sq_tab;color.b, size.b atr_adr.w
sq_lp1:
 ei:halt;:halt


 ld a,(ix):or a:jp m,end_sq;ret m
 inc ix
 ld (sq_colr+1),a

 ld b,(ix):inc ix
 ld l,(ix):inc ix
 ld h,(ix):inc ix

 ld e,b,c,e

sq_lp2:
 push hl
 ld b,e
sq_lp3:
sq_colr: ld (hl),0
;-------------draw squares---------------------
;$58=%01 011 000 $40=01 000 000
;$59=%01 011 001 $48=01 001 000
;$5A=%01 011 010 $50=01 010 000
 push hl
 ld a,h
 and %00000111
  rla:rla:rla
  or $40
 ld h,a
 
 ld (hl),0:inc h
 
 dup 7
 ld (hl),$7F:inc h
edup

 pop hl
;----------------------------------------------
 inc hl:djnz sq_lp3
 pop hl
 ld a,l:add a,32:ld l,a
 ld a,h:adc a,0:ld h,a
 dec c:jp nz,sq_lp2
 jp sq_lp1
end_sq:
 ld hl,0
 ld ($5806),hl,($5808),hl
 ld ($5826),hl,($5828),hl
 ld ($5800+30+4*32),hl,($5800+30+5*32),hl
 ret

cols: db 8,8,8,48,48,48,48,16
	db 16,16,16,24,24,24,56,56
	db 56,48,48,48,40,40,40,24
	db 32,32,32,32,8,8,8,8
lgo: incbin "lasts.bin"

sq_tab:
 db 4;green
 db 2
 dw $5800+30+4*32

 db 5;cyan
 db 2
 dw $5800+28+6*32

 db 6
 db 2
 dw $5800+26+8*32

 db 2; 
 db 2
 dw $5800+24+6*32

 db 5
 db 2
 dw $5800+24+8*32

 db 4
 db 2
 dw $5800+24+10*32
;-
 db 5
 db 2
 dw $5800+22+10*32

 db 6
 db 2
 dw $5800+20+10*32

 db 5
 db 2
 dw $5800+18+10*32

 db 5
 db 2
 dw $5800+18+8*32

 db 5
 db 2
 dw $5800+16+6*32

 db 2
 db 2
 dw $5800+16+8*32

 db 6
 db 2
 dw $5800+14+10*32

 db 5
 db 2
 dw $5800+14+8*32

 db 6
 db 2
 dw $5800+14+6*32

 db 5
 db 8
 dw $5800+6+4*32

 db 2
 db 2
 dw $5800+6+2*32

 db 6
 db 2
 dw $5800+8+0*32

 db 5
 db 2
 dw $5800+6+0*32

 db 4
 db 2
 dw $5800+8+2*32

 db 4
 db 2
 dw $5800+12+12*32

 db 6
 db 2
 dw $5800+10+14*32

 db 5
 db 2
 dw $5800+10+12*32

 db 5
 db 2
 dw $5800+12+14*32

 db 2
 db 4
 dw $5800+6+12*32

 db 2
 db 4
 dw $5800+2+8*32
 
 db 6
 db 4
 dw $5800+2+12*32

 db 4;color,size
 db 4
 dw $5800+2+16*32

;white
 db 7,2
 dw $5800+15+11*32

 db 7,4
 dw $5800+14+10*32

 db 7,6
 dw $5800+13+9*32

 db 7,8
 dw $5800+12+8*32

 db 7,10
 dw $5800+12+7*32

 db 7,12
 dw $5800+10+6*32

 db 7,14
 dw $5800+11+5*32

 db 7,15
 dw $5800+10+4*32

 db 7,16
 dw $5800+9+3*32

 db 7,17
 dw $5800+8+2*32

;----
 db 7,20
 dw $5842

; db $FF
 db 7,20
 dw $5840+10

 db $FF

;------------------------------------------------------------------------------
frames:
 dw fr0,fr1,fr2,fr3,fr4,fr5,fr6,fr7,fr8,fr9,fr10,fr11,fr12,fr13,fr14,fr15
 dw fr16,fr17,fr18,fr19,fr20,fr21,fr22,fr23,fr24,fr25,fr26,fr27,fr28,fr29
 dw fr30,fr31,fr32,fr33,fr34,fr35,fr36,fr37,fr38,fr39,fr40,fr41,fr42,fr43
 dw fr44,fr45,fr46,fr47,fr48,fr49,fr50,fr51,fr52,fr53,fr54,fr55,fr56,fr57
 dw fr58,fr59,fr60,fr61,fr62,fr63,fr64,fr65,fr66,fr67,fr68,fr69,fr70,fr71
 dw fr72,fr73,fr74,fr75,fr76,fr77,fr78,fr79,fr80,fr81,fr82,fr83,fr84,fr85
 dw fr86,fr87,fr88,fr89,fr90,fr91,fr92,fr93,fr94,fr95,fr96,fr97,fr98,fr99
 dw fr100,fr101,fr102,fr103,fr104,fr105,fr106,fr107,fr108,fr109,fr110,fr111
 dw fr112,fr113,fr114,fr115,fr116,fr117,fr118,fr119,fr120,fr121,fr122,fr123
 dw fr124,fr125,fr126,fr127,fr128,fr129,fr130,fr131,fr132,fr133,fr134,fr135
 dw fr136,fr137,fr138,fr139,fr140

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF
 
out_spr:

end

 PAGE 0
 ORG $C000

fr0:incbin "frames\fr0.bin.zx7"
fr1:incbin "frames\fr1.bin.zx7"
fr2:incbin "frames\fr2.bin.zx7"
fr3:incbin "frames\fr3.bin.zx7"
fr4:incbin "frames\fr4.bin.zx7"
fr5:incbin "frames\fr5.bin.zx7"
fr6:incbin "frames\fr6.bin.zx7"
fr7:incbin "frames\fr7.bin.zx7"
fr8:incbin "frames\fr8.bin.zx7"
fr9:incbin "frames\fr9.bin.zx7"
fr10:incbin "frames\fr10.bin.zx7"
fr11:incbin "frames\fr11.bin.zx7"
fr12:incbin "frames\fr12.bin.zx7"
fr13:incbin "frames\fr13.bin.zx7"
fr14:incbin "frames\fr14.bin.zx7"
fr15:incbin "frames\fr15.bin.zx7"
fr16:incbin "frames\fr16.bin.zx7"
fr17:incbin "frames\fr17.bin.zx7"
fr18:incbin "frames\fr18.bin.zx7"
fr19:incbin "frames\fr19.bin.zx7"
fr20:incbin "frames\fr20.bin.zx7"
fr21:incbin "frames\fr21.bin.zx7"
fr22:incbin "frames\fr22.bin.zx7"
fr23:incbin "frames\fr23.bin.zx7"
fr24:incbin "frames\fr24.bin.zx7"
fr25:incbin "frames\fr25.bin.zx7"
fr26:incbin "frames\fr26.bin.zx7"
fr27:incbin "frames\fr27.bin.zx7"
fr28:incbin "frames\fr28.bin.zx7"
fr29:incbin "frames\fr29.bin.zx7"
fr30:incbin "frames\fr30.bin.zx7"
fr31:incbin "frames\fr31.bin.zx7"
fr32:incbin "frames\fr32.bin.zx7"
fr33:incbin "frames\fr33.bin.zx7"
fr34:incbin "frames\fr34.bin.zx7"
fr35:incbin "frames\fr35.bin.zx7"
fr36:incbin "frames\fr36.bin.zx7"
fr37:incbin "frames\fr37.bin.zx7"
fr38:incbin "frames\fr38.bin.zx7"
fr39:incbin "frames\fr39.bin.zx7"
fr40:incbin "frames\fr40.bin.zx7"
fr41:incbin "frames\fr41.bin.zx7"
fr42:incbin "frames\fr42.bin.zx7"
fr43:incbin "frames\fr43.bin.zx7"
fr44:incbin "frames\fr44.bin.zx7"
fr45:incbin "frames\fr45.bin.zx7"
fr46:incbin "frames\fr46.bin.zx7"
fr47:incbin "frames\fr47.bin.zx7"
fr48:incbin "frames\fr48.bin.zx7"
fr49:incbin "frames\fr49.bin.zx7"
fr50:incbin "frames\fr50.bin.zx7"
fr51:incbin "frames\fr51.bin.zx7"
fr52:incbin "frames\fr52.bin.zx7"
fr53:incbin "frames\fr53.bin.zx7"
fr54:incbin "frames\fr54.bin.zx7"
fr55:incbin "frames\fr55.bin.zx7"
fr56:incbin "frames\fr56.bin.zx7"
fr57:incbin "frames\fr57.bin.zx7"
fr58:incbin "frames\fr58.bin.zx7"
fr59:incbin "frames\fr59.bin.zx7"
fr60:incbin "frames\fr60.bin.zx7"
fr61:incbin "frames\fr61.bin.zx7"
fr62:incbin "frames\fr62.bin.zx7"
fr63:incbin "frames\fr63.bin.zx7"
fr64:incbin "frames\fr64.bin.zx7"
fr65:incbin "frames\fr65.bin.zx7"
fr66:incbin "frames\fr66.bin.zx7"
fr67:incbin "frames\fr67.bin.zx7"
fr68:incbin "frames\fr68.bin.zx7"
fr69:incbin "frames\fr69.bin.zx7"
fr70:incbin "frames\fr70.bin.zx7"
fr71:incbin "frames\fr71.bin.zx7"
fr72:incbin "frames\fr72.bin.zx7"
fr73:incbin "frames\fr73.bin.zx7"
fr74:incbin "frames\fr74.bin.zx7"
fr75:incbin "frames\fr75.bin.zx7"
fr76:incbin "frames\fr76.bin.zx7"
fr77:incbin "frames\fr77.bin.zx7"
fr78:incbin "frames\fr78.bin.zx7"
fr79:incbin "frames\fr79.bin.zx7"
fr80:incbin "frames\fr80.bin.zx7"
fr81:incbin "frames\fr81.bin.zx7"
fr82:incbin "frames\fr82.bin.zx7"
fr83:incbin "frames\fr83.bin.zx7"
fr84:incbin "frames\fr84.bin.zx7"
fr85:incbin "frames\fr85.bin.zx7"
fr86:incbin "frames\fr86.bin.zx7"
fr87:incbin "frames\fr87.bin.zx7"
fr88:incbin "frames\fr88.bin.zx7"
fr89:incbin "frames\fr89.bin.zx7"
fr90:incbin "frames\fr90.bin.zx7"
fr91:incbin "frames\fr91.bin.zx7"
fr92:incbin "frames\fr92.bin.zx7"
fr93:incbin "frames\fr93.bin.zx7"
fr94:incbin "frames\fr94.bin.zx7"
fr95:incbin "frames\fr95.bin.zx7"
fr96:incbin "frames\fr96.bin.zx7"
fr97:incbin "frames\fr97.bin.zx7"
fr98:incbin "frames\fr98.bin.zx7"
fr99:incbin "frames\fr99.bin.zx7"
fr100:incbin "frames\fr100.bin.zx7"
fr101:incbin "frames\fr101.bin.zx7"
fr102:incbin "frames\fr102.bin.zx7"
fr103:incbin "frames\fr103.bin.zx7"
fr104:incbin "frames\fr104.bin.zx7"
fr105:incbin "frames\fr105.bin.zx7"
fr106:incbin "frames\fr106.bin.zx7"
fr107:incbin "frames\fr107.bin.zx7"
fr108:incbin "frames\fr108.bin.zx7"
fr109:incbin "frames\fr109.bin.zx7"
fr110:incbin "frames\fr110.bin.zx7"
fr111:incbin "frames\fr111.bin.zx7"
fr112:incbin "frames\fr112.bin.zx7"
fr113:incbin "frames\fr113.bin.zx7"
fr114:incbin "frames\fr114.bin.zx7"
fr115:incbin "frames\fr115.bin.zx7"
fr116:incbin "frames\fr116.bin.zx7"
fr117:incbin "frames\fr117.bin.zx7"
fr118:incbin "frames\fr118.bin.zx7"
fr119:incbin "frames\fr119.bin.zx7"
fr120:incbin "frames\fr120.bin.zx7"
fr121:incbin "frames\fr121.bin.zx7"
fr122:incbin "frames\fr122.bin.zx7"
fr123:incbin "frames\fr123.bin.zx7"
fr124:incbin "frames\fr124.bin.zx7"
fr125:incbin "frames\fr125.bin.zx7"
fr126:incbin "frames\fr126.bin.zx7"
fr127:incbin "frames\fr127.bin.zx7"
fr128:incbin "frames\fr128.bin.zx7"
fr129:incbin "frames\fr129.bin.zx7"
fr130:incbin "frames\fr130.bin.zx7"
fr131:incbin "frames\fr131.bin.zx7"
fr132:incbin "frames\fr132.bin.zx7"
fr133:incbin "frames\fr133.bin.zx7"
fr134:incbin "frames\fr134.bin.zx7"
fr135:incbin "frames\fr135.bin.zx7"
fr136:incbin "frames\fr136.bin.zx7"
fr137:incbin "frames\fr137.bin.zx7"
fr138:incbin "frames\fr138.bin.zx7"
fr139:incbin "frames\fr139.bin.zx7"
fr140:incbin "frames\fr140.bin.zx7"

	display /d,end-begin
 IFNDEF rel
	savesna "title.sna",begin
 ELSE
	savebin "00title.code",begin,end-begin
 ENDIF