 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin
lbu equ $8800
flut equ $BF00
;	ld hl,$5800,de,$5801,bc,767,(hl),l:ldir
	call blackscr;xor a: call fila
	ld hl,$4400,de,$4401,bc,1023,(hl),$FF:ldir
	ld hl,$5400,de,$5401,bc,1023,(hl),$FF:ldir
	ld hl,$4C00,de,$4C01,bc,1023,(hl),$FF:ldir
	ld hl,lbu,de,lbu+1,bc,767,(hl),0:ldir
;generate fade LUT
	ld hl,flut
gl:
	ld a,l
	and 192
	ld c,a
	ld a,l
	and 7
	jr z,nofi
	dec a
nofi:
	or c
	ld c,a
	ld a,l
	and 7*8
	jr z,nofp
	sub 8
nofp:
	or c
	ld (hl),a
	inc l
	jr nz,gl
;prepare routine - stackout, fade table
	ld hl,ou
	ld de,$5800
fo1:
	ld (hl),$E1:inc hl; pop hl
	ld (hl),$22:inc hl ; ld (NN),hl
	ld (hl),e:inc hl
	ld (hl),d:inc hl
	inc de,de
	ld a,d:cp $5B:jr nz,fo1
	ld (hl),$31:inc hl; ld sp,NN
	ld (ous+2),hl
	inc hl,hl

	ld (hl),$21:inc hl
	ld (hl),$00:inc hl
	ld (hl),lbu/256:inc hl

	ld bc,768
fo2:
	ld (hl),$4E:inc hl; ld c,(hl)
	ld (hl),$0A:inc hl; ld a,(bc)
	ld (hl),$77:inc hl; ld (hl),a
	ld (hl),$23:inc hl; inc hl
	dec bc
	ld a,b:or c:jr nz,fo2
	ld (hl),$C9:inc hl;ret

wl: ei:halt
	ld a,(notecnt)
	cp $19:jp z,exitpart
;	and 7:out ($FE),a
; ld a,7:out ($FE),a
; jr $
 call ous
; ld a,0:out ($FE),a
 call movedot
;xy:	ld hl,$03
;dxy:ld bc,$0101
;	call movexy
;	ld (xy+1),hl
;	ld (dxy+1),bc
;xy1:	ld de,$2f0f
;dxy1:ld bc,$FF01
;	ex  de,hl
;	call movexy
;	ex  de,hl
;	ld (xy1+1),de
;	ld (dxy1+1),bc
	call Line;D,H-y,E,L=x
	jp wl
exitpart:
	ld b,8
ep:ei:halt:halt
	push bc
	call ous
	pop bc
	djnz ep
	ret
movedot:
xy:	ld hl,$03
dxy:ld bc,$0101
	call movexy
	ld (xy+1),hl
	ld (dxy+1),bc
xy1:	ld de,$2f0f
dxy1:ld bc,$FF01
	ex  de,hl
	call movexy
	ex  de,hl
	ld (xy1+1),de
	ld (dxy1+1),bc
	ret
movexy:;b=dx,c=dy
	ld a,h
	add a,b
	ld h,a
	jr z,chdx
	cp $2f:jr nz,conty
chdx:
	ld a,b
	neg
	ld b,a
conty:
	ld a,l
	add a,c
	ld l,a
	jr z,chdy
	cp $1F:jr nz,endm
chdy:
	ld a,c
	neg
	ld c,a
endm:
	ret
Line:
; * parameters : 
;    - DE : coordinates of the 1st point
;    - HL : coordinates of the 2nd point

        push    DE              ;can be removed
        push    HL              ;can be removed

        ld      A,D
        sub     H
        jr      NC,DXPositive    ;delta_x > 0
DXNegative:
        neg
DXPositive:
        ld      B,A              ;B <- |delta_x|
        ld      A,E
        sub     L
        jr      NC,DYPositive    ;delta_y > 0
DYNegative:
        neg
DYPositive:                
        sub     B               ;|delta_y|
        push    AF
        jr      C,DeltaX        ;|delta_x| > |delta_y|
DeltaY:
        ld      A,H             ;if |delta_x| < |delta_y| then
        ld      H,L             ;then values x and y are swapped
        ld      L,A             ;so the loop will always be performed on the
        ld      A,D             ;x value. A flag must be set to 
        ld      D,E             ;remind that data must be drawn (y,x) 
        ld      E,A             ;instead of (x,y)

        ;ld      A,$01           
        ;ld      (Flag),A        ;the Flag !!!
DeltaX:
        ld      A,D
        sub     H
        jr      NC,TestDY        ;x1 < x2 
TestDX:
        ex	DE,HL
TestDY:
        ld      A,E
        sub     L
        ld      A,$01
        jr      NC,StoreA
        neg                     ;y1 > y2 : in case2 the 'y' variable
StoreA:
        ld      (Way+1),A
InitLine:       
        ld      B,H
        ld      C,L
        ld      A,E
        sub     L
        jr      NC,EndInit
        ld      A,L
        ld      L,E
        ld      E,A
EndInit:
        ld      A,E      
        sub     L
        rla
        ld      L,A             ;value to add in case1 (d < 0)
        add     A,H
        sub     D
        ld      E,A             ;'d' variable is initialised
        add     A,H
        sub     D
        ld      H,A             ;value to add in case2 (d >= 0)
Loop:
        ld      A,B
        sub     D
        jr      NC,EndLine       ;the line is completely drawn.
        pop     AF
        ;ld      A,(Flag)
        bit     7,A
        push    AF
        push    AF
        push    BC
        jr      Z,DrawPoint
        ld      A,B
        ld      B,C
        ld      C,A
DrawPoint:     
;		jr $
		push hl
 ;       CALL_(PointOn);B=X,C=y
 		ld h,0,l,c
 		srl l
 		ld a,7*8
 		jr nc,noink
 		ld a,7
noink
 		add hl,hl
 		add hl,hl
 		add hl,hl
 		ld h,$22
 		add hl,hl
 		add hl,hl
 		push af
 		ld a,l
 		add a,b
 		ld l,a
 		jr nc,noih
 		inc h
noih
 		pop af
 		or (hl)
 		ld (hl),a
 		pop hl
        pop     BC
        pop     AF
TestD:
        bit     7,E
        jr      NZ,Case1
Case2:                          ;d >= 0 
        ld      A,E
        add     A,H
        ld      E,A
Way:        ld      A,0;(Way)
        add     A,C
        ld      C,A
        jr      EndLoop
Case1:                          ;d < 0
        ld      A,E
        add     A,L
        ld      E,A
EndLoop:
        inc     B
        jr      Loop
EndLine:
        pop     AF              ;MUST NOT BE REMOVED
        pop     HL              ;can be removed
        pop     DE              ;can be removed
        ret

PointOn:
;        push    DE              ;MUST NOT BE REMOVED
;        push    HL              ;MUST NOT BE REMOVED
;        ROM_CALL(FIND_PIXEL)
;        ld      DE,$FC00
;        add     HL,DE
;        or      (HL)
;        ld      (HL),A
;        pop     HL              ;MUST NOT BE REMOVED
;        pop     DE              ;MUST NOT BE REMOVED
; 		ld h,0,l,c
; 		srl l
; 		ld a,7*8
; 		jr nc,noink1
; 		ld a,7
;noink1
; 		add hl,hl
; 		add hl,hl
; 		add hl,hl
; 		ld h,22
; 		add hl,hl
; 		add hl,hl
; 		push af
; 		ld a,l
; 		or b
; 		ld l,a
; 		pop af
; 		or (hl)
; 		ld (hl),a
; 		pop hl
;
;        ret             

;end
;	display /d,end-begin
;	savesna "!void.sna",begin

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

ous: ld (0),sp
	ld sp,lbu
	ld b,flut/256
ou:
end

 IFNDEF rel
	savesna "walkl.sna",begin
 ELSE
	savebin "06walkl.code",begin,end-begin
 ENDIF
 
