;   utils.inc
; uservar1 - 4
	device zxspectrum128
        ORG #5C00

begin
 di
 jp start_demo
 include "utils.inc"
callbyHL: jp (hl)
;--------------int--------
INTVEC  PUSH AF,BC,DE,HL,IX
        EXX:PUSH AF,BC,DE,HL
        EXA:PUSH AF

        ld hl,(callb4)
        ld a,h:or l:call nz,callbyHL

        ld a,(curpage):and #18:or 1
        ld bc,#7FFD:out (c),a
        call PLAY
 ld a,(CurPos)
 ld (notecnt),a
        ld a,(curpage)
        ld bc,#7FFD:out (c),a
v1:ld hl,0:inc hl:ld (v1+1),hl,(intcnt),hl
        POP AF:EXA
        POP HL,DE,BC,AF:EXX
        POP IX,HL,DE,BC,AF
        EI:RETI

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_demo:


 ld sp,#5ff0

 xor a:out (#FE),a
 ld a,#10,(curpage),a
 ld hl,#5AFF,de,#5AFE,(hl),0,bc,6144:lddr; 
 ld a,#11,bc,#7FFD:out (c),a
 ld hl,song:call INIT
; call initprint
;------setup interrupt-----------------
 LD A,#5B,I,A:IM 2
 LD HL,INTVEC,(#5BFF),HL

;--------------------------title
 ;jr $

;00intro
 ld a,#10
 call bank02
 ld de,#6000
 ld hl,part1b
 ld bc,part1e-part1b
 call runpart1; just copy, no halt

;01spiral
 ld a,#13
 ld de,#6000
 ld hl,part2b
 ld bc,part2e-part2b
 call runpart2; 

;02girl
 ld a,#13
 ld de,#6000
 ld hl,part3b
 ld bc,part3e-part3b
 call runpart2; 

;03ide
 ld a,#13
 ld de,#6000
 ld hl,part4b
 ld bc,part4e-part4b
 call runpart2; 

;04square
 ld a,#13
 ld de,#6000
 ld hl,part5b
 ld bc,part5e-part5b
 call runpart2; 

;05 greets
 ld a,#13
 ld de,#6000
 ld hl,part6b
 ld bc,part6e-part6b
 call runpart2; 

;06walkline
 ld a,#13
 ld de,#6000
 ld hl,part7b
 ld bc,part7e-part7b
 call runpart2; 

;08rainbow
 ld a,#13
 ld de,#6000
 ld hl,part8b
 ld bc,part8e-part8b
 call runpart2; 

stp:
	ld a,(notecnt)
	and 7
	out ($FE),a
	jr stp

end


 PAGE 0
 ORG $C000
page0b:
fr0:incbin "frames\fr0.bin.zx7"
fr1:incbin "frames\fr1.bin.zx7"
fr2:incbin "frames\fr2.bin.zx7"
fr3:incbin "frames\fr3.bin.zx7"
fr4:incbin "frames\fr4.bin.zx7"
fr5:incbin "frames\fr5.bin.zx7"
fr6:incbin "frames\fr6.bin.zx7"
fr7:incbin "frames\fr7.bin.zx7"
fr8:incbin "frames\fr8.bin.zx7"
fr9:incbin "frames\fr9.bin.zx7"
fr10:incbin "frames\fr10.bin.zx7"
fr11:incbin "frames\fr11.bin.zx7"
fr12:incbin "frames\fr12.bin.zx7"
fr13:incbin "frames\fr13.bin.zx7"
fr14:incbin "frames\fr14.bin.zx7"
fr15:incbin "frames\fr15.bin.zx7"
fr16:incbin "frames\fr16.bin.zx7"
fr17:incbin "frames\fr17.bin.zx7"
fr18:incbin "frames\fr18.bin.zx7"
fr19:incbin "frames\fr19.bin.zx7"
fr20:incbin "frames\fr20.bin.zx7"
fr21:incbin "frames\fr21.bin.zx7"
fr22:incbin "frames\fr22.bin.zx7"
fr23:incbin "frames\fr23.bin.zx7"
fr24:incbin "frames\fr24.bin.zx7"
fr25:incbin "frames\fr25.bin.zx7"
fr26:incbin "frames\fr26.bin.zx7"
fr27:incbin "frames\fr27.bin.zx7"
fr28:incbin "frames\fr28.bin.zx7"
fr29:incbin "frames\fr29.bin.zx7"
fr30:incbin "frames\fr30.bin.zx7"
fr31:incbin "frames\fr31.bin.zx7"
fr32:incbin "frames\fr32.bin.zx7"
fr33:incbin "frames\fr33.bin.zx7"
fr34:incbin "frames\fr34.bin.zx7"
fr35:incbin "frames\fr35.bin.zx7"
fr36:incbin "frames\fr36.bin.zx7"
fr37:incbin "frames\fr37.bin.zx7"
fr38:incbin "frames\fr38.bin.zx7"
fr39:incbin "frames\fr39.bin.zx7"
fr40:incbin "frames\fr40.bin.zx7"
fr41:incbin "frames\fr41.bin.zx7"
fr42:incbin "frames\fr42.bin.zx7"
fr43:incbin "frames\fr43.bin.zx7"
fr44:incbin "frames\fr44.bin.zx7"
fr45:incbin "frames\fr45.bin.zx7"
fr46:incbin "frames\fr46.bin.zx7"
fr47:incbin "frames\fr47.bin.zx7"
fr48:incbin "frames\fr48.bin.zx7"
fr49:incbin "frames\fr49.bin.zx7"
fr50:incbin "frames\fr50.bin.zx7"
fr51:incbin "frames\fr51.bin.zx7"
fr52:incbin "frames\fr52.bin.zx7"
fr53:incbin "frames\fr53.bin.zx7"
fr54:incbin "frames\fr54.bin.zx7"
fr55:incbin "frames\fr55.bin.zx7"
fr56:incbin "frames\fr56.bin.zx7"
fr57:incbin "frames\fr57.bin.zx7"
fr58:incbin "frames\fr58.bin.zx7"
fr59:incbin "frames\fr59.bin.zx7"
fr60:incbin "frames\fr60.bin.zx7"
fr61:incbin "frames\fr61.bin.zx7"
fr62:incbin "frames\fr62.bin.zx7"
fr63:incbin "frames\fr63.bin.zx7"
fr64:incbin "frames\fr64.bin.zx7"
fr65:incbin "frames\fr65.bin.zx7"
fr66:incbin "frames\fr66.bin.zx7"
fr67:incbin "frames\fr67.bin.zx7"
fr68:incbin "frames\fr68.bin.zx7"
fr69:incbin "frames\fr69.bin.zx7"
fr70:incbin "frames\fr70.bin.zx7"
fr71:incbin "frames\fr71.bin.zx7"
fr72:incbin "frames\fr72.bin.zx7"
fr73:incbin "frames\fr73.bin.zx7"
fr74:incbin "frames\fr74.bin.zx7"
fr75:incbin "frames\fr75.bin.zx7"
fr76:incbin "frames\fr76.bin.zx7"
fr77:incbin "frames\fr77.bin.zx7"
fr78:incbin "frames\fr78.bin.zx7"
fr79:incbin "frames\fr79.bin.zx7"
fr80:incbin "frames\fr80.bin.zx7"
fr81:incbin "frames\fr81.bin.zx7"
fr82:incbin "frames\fr82.bin.zx7"
fr83:incbin "frames\fr83.bin.zx7"
fr84:incbin "frames\fr84.bin.zx7"
fr85:incbin "frames\fr85.bin.zx7"
fr86:incbin "frames\fr86.bin.zx7"
fr87:incbin "frames\fr87.bin.zx7"
fr88:incbin "frames\fr88.bin.zx7"
fr89:incbin "frames\fr89.bin.zx7"
fr90:incbin "frames\fr90.bin.zx7"
fr91:incbin "frames\fr91.bin.zx7"
fr92:incbin "frames\fr92.bin.zx7"
fr93:incbin "frames\fr93.bin.zx7"
fr94:incbin "frames\fr94.bin.zx7"
fr95:incbin "frames\fr95.bin.zx7"
fr96:incbin "frames\fr96.bin.zx7"
fr97:incbin "frames\fr97.bin.zx7"
fr98:incbin "frames\fr98.bin.zx7"
fr99:incbin "frames\fr99.bin.zx7"
fr100:incbin "frames\fr100.bin.zx7"
fr101:incbin "frames\fr101.bin.zx7"
fr102:incbin "frames\fr102.bin.zx7"
fr103:incbin "frames\fr103.bin.zx7"
fr104:incbin "frames\fr104.bin.zx7"
fr105:incbin "frames\fr105.bin.zx7"
fr106:incbin "frames\fr106.bin.zx7"
fr107:incbin "frames\fr107.bin.zx7"
fr108:incbin "frames\fr108.bin.zx7"
fr109:incbin "frames\fr109.bin.zx7"
fr110:incbin "frames\fr110.bin.zx7"
fr111:incbin "frames\fr111.bin.zx7"
fr112:incbin "frames\fr112.bin.zx7"
fr113:incbin "frames\fr113.bin.zx7"
fr114:incbin "frames\fr114.bin.zx7"
fr115:incbin "frames\fr115.bin.zx7"
fr116:incbin "frames\fr116.bin.zx7"
fr117:incbin "frames\fr117.bin.zx7"
fr118:incbin "frames\fr118.bin.zx7"
fr119:incbin "frames\fr119.bin.zx7"
fr120:incbin "frames\fr120.bin.zx7"
fr121:incbin "frames\fr121.bin.zx7"
fr122:incbin "frames\fr122.bin.zx7"
fr123:incbin "frames\fr123.bin.zx7"
fr124:incbin "frames\fr124.bin.zx7"
fr125:incbin "frames\fr125.bin.zx7"
fr126:incbin "frames\fr126.bin.zx7"
fr127:incbin "frames\fr127.bin.zx7"
fr128:incbin "frames\fr128.bin.zx7"
fr129:incbin "frames\fr129.bin.zx7"
fr130:incbin "frames\fr130.bin.zx7"
fr131:incbin "frames\fr131.bin.zx7"
fr132:incbin "frames\fr132.bin.zx7"
fr133:incbin "frames\fr133.bin.zx7"
fr134:incbin "frames\fr134.bin.zx7"
fr135:incbin "frames\fr135.bin.zx7"
fr136:incbin "frames\fr136.bin.zx7"
fr137:incbin "frames\fr137.bin.zx7"
fr138:incbin "frames\fr138.bin.zx7"
fr139:incbin "frames\fr139.bin.zx7"
fr140:incbin "frames\fr140.bin.zx7"
part1b:
 incbin "00title.code"
part1e:

page0e:
;---------------------------------------------------
		PAGE 1
        ORG #C000
page1b:
plyer:include "PTxPlay.a80"
song:incbin "scrusad-music.sna.PT3"

page1e:

 PAGE 3
 ORG $C000
page3b:

part2b:
 incbin "01spiral.code"
part2e:

part3b:
 incbin "02girl.code"
part3e:

part4b:
 incbin "03ide.code"
part4e:

part5b:
 incbin "04sq.code"
part5e:

part6b:
 incbin "05greets.code"
part6e:

part7b:
 incbin "06walkl.code"
part7e:

part8b:
 incbin "07rainbow.code"
part8e:

page3e:



	LUA

	local fp = assert(io.open("demovars.inc", "wb"))


   local ss=tostring( sj.get_label("uservar1") )
   ss=string.gsub(ss , "%s", "")
   fp:write("uservar1=")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("curpage") )
   ss=string.gsub(ss , "%s", "")
   fp:write("curpage =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("notecnt") )
   ss=string.gsub(ss , "%s", "")
   fp:write("notecnt =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("intcnt") )
   ss=string.gsub(ss , "%s", "")
   fp:write("intcnt =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("callb4") )
   ss=string.gsub(ss , "%s", "")
   fp:write("callb4 =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("dzx7_standard") )
   ss=string.gsub(ss , "%s", "")
   fp:write("dzx7_standard =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("nbde") )
   ss=string.gsub(ss , "%s", "")
   fp:write("nbde =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("nbhl") )
   ss=string.gsub(ss , "%s", "")
   fp:write("nbhl =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

   local ss=tostring( sj.get_label("fila") )
   ss=string.gsub(ss , "%s", "")
   fp:write("fila =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")

--   local ss=tostring( sj.get_label("texto") )
--   ss=string.gsub(ss , "%s", "")
--   fp:write("texto =")
--   fp:write(string.format("#%x",ss) )
--   fp:write("\r\n")
   
   local ss=tostring( sj.get_label("bank01") )
   ss=string.gsub(ss , "%s", "")
   fp:write("bank01 =")
   fp:write(string.format("#%x",ss) )
   fp:write("\r\n")
   
   local ss=tostring( sj.get_label("bank02") )
   ss=string.gsub(ss , "%s", "")
   fp:write("bank02 =")
   fp:write(string.format("#%x",ss) )
   fp:write(";no halt to switch\r\n")

   local ss=tostring( sj.get_label("blackscr") )
   ss=string.gsub(ss , "%s", "")
   fp:write("blackscr =")
   fp:write(string.format("#%x",ss) )
   fp:write(";black screen\r\n")
	assert(fp:close())
	ENDLUA

;-----------------------------------------------------------
 macro	sectors datab,datae

 IF low (datae-datab)=0
   db 1,5,high (datae-datab)
 ELSE
   db 1,5,(1+high (datae-datab))
 ENDIF

	endm

 MODULE boot
Basic:
 db #00,#01; 
 DW EndLine1 - Line1
Line1:
 db #EA;REM
 ld sp,#5FFE

    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

 di
 ld de,(#5CF4)
 ld hl, #C000
 sectors page0b,page0e
 call #3d13

 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#11,bc,#7FFD:out (c),a
 sectors page1b,page1e
 call #3d13

 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#13,bc,#7FFD:out (c),a
 sectors page3b,page3e
 call #3d13

; di
; ld de,(#5CF4)
; ld hl, #C000
; ld a,#14,bc,#7FFD:out (c),a
; sectors page4b,page4e
; call #3d13
;
; di
; ld de,(#5CF4)
; ld hl, #C000
; ld a,#16,bc,#7FFD:out (c),a
; sectors page6b,page6e
; call #3d13
 
  di
 ld a,#d5,(#5b00),a
 ld a,#ed,(#5b01),a
 ld a,#b0,(#5b02),a
 ld a,#c9,(#5b03),a
 ld a,#10,bc,#7ffd:out (c),a
 ld hl,#6000
 ld de,#5C00
 ld bc,end-begin
 jp #5b00


 db "whut?7"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29,#0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

    EMPTYTRD "lasts.trd" ;create empty TRD image
	SAVETRD "lasts.trd", "lasts.B", boot.Basic, boot.EndBasic - boot.Basic
    SAVETRD "lasts.trd","demo.C",begin,end-begin

    PAGE 0
    SAVETRD "lasts.trd","pg0.C",page0b,page0e-page0b
    PAGE 1
    SAVETRD "lasts.trd","pg1.C",page1b,page1e-page1b
    PAGE 3
    SAVETRD "lasts.trd","pg3.C",page3b,page3e-page3b
;    PAGE 4
;    SAVETRD "makes.trd","pg4.C",page4b,page4e-page4b
;    PAGE 6
;    SAVETRD "makes.trd","pg6.C",page6b,page6e-page6b

	display /d,end-begin
	savesna "lasts.sna",begin

;-----------------------------------------------------------
