 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin

chunkplace equ $b100
adrs equ $B000

;	call blackscr
;	ld a,$47:call fila
	ld hl,$4000,b,16
z1:
	push hl
z2:
	ld (hl),0:inc l
	ld a,l
	and 31
	jr nz,z2
	pop hl
	call nbhl
	djnz z1
	ld hl,$5800,de,$5801,bc,63,(hl),$47:ldir
 ld a,$17:ei:call bank01
 ld hl,$4000,de,$c000,bc,6912:ldir

	ld a,$10:call bank02
;depack
	ld hl,sprp
	ld de,$8000
	call dzx7_standard

;gen chunkys
 ld d,chunkplace/256
 call _ch_clt
;-generate edress
 ld hl,adrs
 ld de,$C000+32*2+2
 ld b,40
gen_a:
 ld (hl),e:inc hl
 ld (hl),d:inc hl
 
 call nbde
 call nbde
 call nbde
 call nbde

 djnz gen_a
;--prepare output
 ld hl,out4x4_b
 ld de,out4x4_e
 ld bc,(out4x4_e-out4x4_b)*13
 ldir
 ld a,$C9,(de),a

	ld a,(notecnt)
	inc a,a
	ld (tv31+1),a
;	ld ix,t1,de,$4000
;	call tout
lp1:;ei:halt
page:ld a,$1D
 xor $0A
 ld (page+1),a
 ei:call bank01
;5c0b=8
	ld a,(notecnt)
	cp 8
	jr nz,noexit;ret z
	xor a:call fila
	ld a,$10
	ei:jp bank01

noexit:
rpo: call to1
frame_c:ld a,0
 dec a;inc a
 and 7
 ld (frame_c+1),a
 
 ld l,a,h,0
 add hl,hl
 ld de,frametab
 add hl,de
 ld a,(hl):inc hl
 ld h,(hl),l,a
 
 ;ld a,0:out ($FE),a
; ld a,(notecnt):and 7:out ($FE),a
; push bc
 ld ix,adrs
 ld a,40
out1: exa
 ld e,(ix):inc ix
 ld d,(ix):inc ix
 ld b,chunkplace/256
 call out4x4_b
 exa
 dec a:jr nz,out1
; ld a,7:out ($FE),a
 jp lp1

to1: ld ix,t1
	ld de,$C000
	call tout
	ld hl,to2,(rpo+1),hl
	ret
to2: ld ix,t1
	ld de,$C000
	call tout
	ld hl,to3,(rpo+1),hl
	ret
to3:
	ld a,(notecnt)
tv31: cp 0
		ret nz
		inc a
		ld (tv31+1),a
tv3: ld hl,tea
	ld e,(hl):inc hl
	ld d,(hl):inc hl
	ld a,d:or e:ret z
	ld (tv3+1),hl
	ld (to1+2),de
	ld (to2+2),de
	ld hl,to1,(rpo+1),hl
	ret
tea: dw t2,t3,0
;--------------text routines---------------------------
tout: ;IX=text
	ld a,(ix):inc ix
	or a
	ret z
	ld l,a,h,0,bc,fnt-256
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,8
	push de
chl:
	ld a,(hl)
	ld (de),a
	call nbde
	ld a,(hl)
	ld (de),a
	call nbde
	inc hl
	djnz chl
	pop de
	inc e
	jr tout
fnt:incbin "bal.fnt"
t1: db "   Last Stand started in 2017  ",0
t2: db "       But it was stopped      ",0
t3: db "   Still, I hope to win (:     ",0
;------------------------------------------------------
frametab:
n=0
 dup 9
 dw $8000+n*28*40
n=n+1
edup
;  chunk'
;   d-.    chunks
_ch_clt ld e,0
i_chun0 ld a,e
        and 15
        add a,a
        ld c,a
        ld b,0
        ld hl,c_obraz
        add hl,bc
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld b,4
i_chun2 xor a
        ld c,4
i_chun3 add hl,hl
        rra
        dec c
        jr nz,i_chun3
        ld (de),a
        inc d
        djnz i_chun2
        ld a,e
        and #f0
        rrca
        rrca
        rrca
        rrca
        ld l,a
        ld b,4
i_chun4 dec d
        ld h,d
        ld a,(hl)
        rrca
        rrca
        rrca
        rrca
        and 15
        ld c,a
        ld a,(de)
        or c
        ld (de),a
        djnz i_chun4
        inc e
        jr nz,i_chun0
        ret
c_obraz dw #0000,#8020,#a020,#a0a0
        dw #a4a0,#a4a1,#a5a1,#a5a5
        dw #b5a5,#e5b5,#f5b5,#f5f5
        dw #fdf5,#fdf7,#fff7,#ffff
;    - 92 
;C U l8r.  Virtual/Brainwave of X-Project.


 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

out4x4_b:
 ld c,(hl):inc hl
 ld a,(bc),(de),a:inc b,d
 ld a,(bc),(de),a:inc b,d
 ld a,(bc),(de),a:inc b,d
 ld a,(bc),(de),a
 inc e

 ld c,(hl):inc hl
 ld a,(bc),(de),a:dec b,d
 ld a,(bc),(de),a:dec b,d
 ld a,(bc),(de),a:dec b,d
 ld a,(bc),(de),a
 inc e
out4x4_e:

sprp:incbin "swirl_.bin.zx7"
end

	display /d,end-begin
 IFNDEF rel
	savesna "title.sna",begin
 ELSE
	savebin "01spiral.code",begin,end-begin
 ENDIF