 DEFINE rel ;comment for sna,un for code
	device zxspectrum48
        ORG #6000
begin

	call blackscr
	ld a,$44:call fila
	ld a,$10:ei:call bank01
;zero memory
	ld hl,$A000
zm:
	ld (hl),0
	inc l
	jr nz,zm
	inc h
;	ld a,h
;	cp $C0
	jr nz,zm

		ld	hl, sdata;unk_63A6
		ld	de, #7c00
		ld	c, e
		ld	xl, 10h
loc_600F:
		ld	b, 4
loc_6011:
		xor	a
		rl	(hl)
		rla
		rl	(hl)
		rla
		add	a, c
		ld	c, a
		ld	(de), a
		inc	e
		djnz	loc_6011
		inc	hl
		dec	xl
		jr	nz, loc_600F
		ld	h, d
		ld	l, e

loc_6027:
		ld	(de), a
		inc	e
		dec	l
		ld	a, (hl)
		jr	nz, loc_6027

;	jr $
; de=$7c80,hl=$7c00

loc_602D:
		ld	a, (hl)
		sra a
		ld (hl),a
		neg
		ld	(de), a
		inc	de
		inc	l
		jr	nz, loc_602D

PLOTTBL EQU #7D00

FORMER  LD DE,#4000,BC,#8000,L,E
FLP1    LD H,high PLOTTBL
        LD (HL),B:INC H:LD (HL),C:INC H
        LD (HL),E:INC H:LD (HL),D
        RRC B
        LD A,C:ADC A,0:LD C,A
FBR1    INC D:LD A,D:AND 7
        JR NZ,FNXT:LD A,E:ADD A,32
        LD E,A:JR C,FNXT
        LD A,D:SUB 8:LD D,A
FNXT    INC L:JR NZ,FLP1
;------------form stack cls---------
;pointsdata equ $A000
; ld hl,pointsdata
;cllp1:
; ld (hl),0:inc l:jr nz,cllp1
; inc h:jr nz,cllp1
clearp equ $C000;for clear points
 ld b,0
 ld hl,clearp
form1:
 ld (hl),$e1:inc hl
 ld (hl),$f1:inc hl
 ld (hl),$72:inc hl
 inc b
 jr nz,form1
 ld de,back1
 ld (hl),$C3:inc hl
 ld (hl),e:inc hl
 ld (hl),d:inc hl

plotp equ $C400
 ld hl,plotp
 ld b,0
form2:
 ld (hl),$e1:inc hl
 ld (hl),$f1:inc hl
 ld (hl),$B6:inc hl
 ld (hl),$77:inc hl
 inc b
 jr nz,form2
 ld de,back2
 ld (hl),$C3:inc hl
 ld (hl),e:inc hl
 ld (hl),d:inc hl

; ld hl,$5800,de,$5803,bc,767
; ld (hl),$40+7*8:ldir

lp:;ei:halt
 ;ld a,0
; out ($FE),a
; ld a,(notecnt)
; and 7
; out ($FE),a

sw:ld a,1:xor 1:ld (sw+1),a
 ld l,a,h,0
 add hl,hl
 ld de,hl
 add hl,hl
 add hl,de;*6
 ld de,stack_tab
 add hl,de
 
 ld e,(hl):inc hl
 ld d,(hl):inc hl
 ld (spv1+1),de ;erase adr

 ld e,(hl):inc hl
 ld d,(hl):inc hl
 ld (spv2+1),de ;plot

 ld e,(hl):inc hl
 ld d,(hl):inc hl
 ld (spv3+1),de

	ld (sav_sp+1),sp
spv3:ld sp,$a800+4*256
 ld ixl,0
cntr:ld bc,0
 inc b,b
 inc b,b
 ld (cntr+1),bc
plot_lp:;b=t,c=2*t
 ld h,$7C
 ld l,b
 ld a,(hl)
 add a,a;2*cos(t)
 ld l,c
 sub(hl);+cos(2t)

 add a,96-16;;+16;-32+8
 ld d,a; got Y
 
 ld a,b:add a,$40
 ld l,a
 ld e,(hl)
 ld a,c:add a,$40
 ld l,a
 ld a,e
 add a,a
 add a,(hl)
 add a,128-40+16
 ld e,a
 
 inc h;ld H,HIGH PLOTTBL
 ld l,e
 ld e,(hl):inc h;bitweight
 ld a,(hl):inc h;disp X
 ld l,d
 or (hl):inc h
 ld h,(hl)
 ld l,a
; ld a,(hl):xor e:ld (hl),a
 ld a,e
 push af,hl
 inc b
 inc c,c
op1: inc c
 inc ixl
 jp nz,plot_lp
sav_sp:ld sp,0

	ei:halt
; ld a,(notecnt)
; and 7
; out ($FE),a

 ld a,(notecnt)
 cp $0D:;ret z
 jr nz,noexit
 xor a:jp fila
noexit:
 cp $0C:jr nz,setpar2
 xor a:ld (op1),a
setpar2:

 ld (back1+1),sp;         erase pixels
spv1:ld sp,$A000
 ld d,0
 jp clearp
back1:ld sp,0
; ld a,1:out ($FE),a

 ld (back2+1),sp;        plot pixels
spv2:ld sp,$A500
 jp plotp
back2:ld sp,0
; ld a,6:out ($FE),a

 jp lp
stack_tab:
 dw $a000,$a800,$a800+4*256
 dw $a800,$a000,$a000+4*256

sdata:;unk_63A6:
		db    026h
		db    066h
		db    066h
		db    066h
		db    065h
		db    096h
		db    059h
		db    055h
		db    095h
		db    055h
		db    015h
		db    045h
		db    011h
		db    010h
		db    041h
		db    0

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

end

 IFNDEF rel
	savesna "ide.sna",begin
 ELSE
	savebin "03ide.code",begin,end-begin
 ENDIF
 
