 DEFINE rel ;comment for sna,un for code
	device zxspectrum48
        ORG #6000
begin
	call blackscr
	ld a,$10:ei:call bank01
;zero mmemory
	ld hl,$C000
	xor a
zm: ld (hl),a
	inc hl
	cp h
	jr nz,zm
;gen stack
	ld ix,ou
	ld de,$C000; SP
	ld hl,$5800
fo1:
	ld (ix),$31:inc ix;ld sp,NN
	ld (ix),e:inc ix
	ld (ix),d:inc ix
	inc d
	ld b,16
fo2:
	ld (ix),$e1:inc ix;pop hl
	ld (ix),$22:inc ix;ld (NN),hl
	ld (ix),l:inc ix
	ld (ix),h:inc ix
	inc hl,hl
	djnz fo2

	ld b,16
fo3:
	ld (ix),$d5:inc ix;push de
	djnz fo3
	ld a,h
	cp $5b
	jr nz,fo1

	ld (ix),$31:inc ix;ld sp,NN
	ld (ous+2),ix
	inc ix,ix
	ld (ix),$C9:inc ix;ret

lp1:
	ei:halt
	ld hl,(intcnt)
	ld de,$0A9B
	xor a:sbc hl,de
	jp nc,fila
;	ld a,(notecnt)
;	and 7:out ($FE),a

;	ld a,7:out ($FE),a
	call ous
;	ld a,0:out ($FE),a
;	jr $
;proceed square
	call proc_sq

;	ld a,6:out ($FE),a
	
	jp lp1
;-----------------------------
proc_sq:
	ld a,0
	inc a
	ld (proc_sq+1),a
;	and 1:ret z

	ld ix,sq_tb
	ld a,(sq_te-sq_tb)/(str_e-str_b)
sqlp:
	exa
	ld h,(ix+3);Y
	ld c,(ix+1);color
	ld e,(ix+2);size
sqy:
	ld l,(ix+0);X
	ld b,(ix+2);size
sqx:
	ld a,(hl)
	ld (hl),c
	cp 9: jr nz,nocol
	ld a,c
	cp $28
	jr nz,nocol
	set 6,(hl)
nocol:
	inc l:djnz sqx
	inc h
	dec e
	jr nz,sqy

;mov sq
;skip if flag
	ld a,(proc_sq+1)
	and 1
	jr nz,nomovesq
	ld a,(ix+3)
	sub (ix+4)
	cp $B8 ;arg1 <= a  Carry reset
	jr nc,sqcont
	ld a,$D8
sqcont
	ld (ix+3),a
nomovesq:
;next in table
	inc ix,ix,ix,ix,ix
	exa
	dec a
	jp nz,sqlp
	ret
;-----------------------------
sq_tb:

str_b:
 db 0; X
 db 9; color
 db 4 ; size
 db $D8; Y
 db 1;dy
str_e:

 db 5; X
 db 9; color
 db 6 ; size
 db $D9; Y
 db 2;dy

 db 12; X
 db 9; color
 db 7 ; size
 db $D9; Y
 db 1;dy

 db 12; X
 db 9; color
 db 3 ; size
 db $E1; Y
 db 1;dy

 db 21; X
 db 9; color
 db 3 ; size
 db $D7; Y
 db 1;dy

 db 21; X
 db 9; color
 db 3 ; size
 db $D7+4; Y
 db 1;dy

 db 25; X
 db 9; color
 db 3 ; size
 db $D7; Y
 db 1;dy

;color=5
 db 22; X
 db $28; color
 db 3 ; size
 db $D9; Y
 db 2;dy

 db 26; X
 db $28; color
 db 4 ; size
 db $D8; Y
 db 3;dy

 db 6; X
 db $28; color
 db 2 ; size
 db $D8; Y
 db 1;dy

 db 9; X
 db $28; color
 db 4 ; size
 db $D9; Y
 db 3;dy

 db 1; X
 db $28; color
 db 2 ; size
 db $DA; Y
 db 2;dy

sq_te:

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

ous: ld (0),sp
	ld de,0
ou:
end

 IFNDEF rel
	savesna "square.sna",begin
 ELSE
	savebin "04sq.code",begin,end-begin
 ENDIF
 
