 DEFINE rel ;comment for sna,un for code

	device zxspectrum128
        ORG #6000
begin

;prep routine
	ld hl,ou
	ld b,96
fo1:
	ld (hl),$E5 :inc hl; push hl
	ld (hl),$D5 :inc hl;push de
	ld (hl),$C5 :inc hl;push bc
	ld (hl),$F5 :inc hl;push af
	djnz fo1
	ld de,spa
	ld (hl),$2A :inc hl ; ls hl,(NN)
	ld (hl),e :inc hl
	ld (hl),d :inc hl
	ld bc,6144/2
fo2:
	ld (hl),$E5 :inc hl; push hl
	dec bc
	ld a,b:or c:jr nz,fo2
	ld (hl),$31 :inc hl; ld sp,NN
	ld (ous+2),hl
	inc hl,hl
	ld (hl),$C9:inc hl;ret
	ld (fpo+1),hl
;generate logo
	ld ix,lgo
	ld (hl),$3E:inc hl
	ld (hl),$52:inc hl;ld a,N
	ld a,3
	ld de,$D944
gl1:
	exa
	push de
	ld bc,$8003
gl2
	ld a,(ix+0):and b:jr z,nodata
	ld (hl),$32:inc hl; ld(NN),a
	ld (hl),e:inc hl
	ld (hl),d:inc hl
nodata:
	inc de
	rrc b:jr nc,gl2
	inc ix
	dec c:jr nz,gl2
	pop de
	ld a,e:add a,32:ld e,a
	ld a,d:adc a,0:ld d,a
	exa
	dec a:jr nz,gl1
	ld (hl),$C9:inc hl;ret

;wait pattern
wp:ld a,(notecnt):cp $1A:jr nz,wp

rlp:

pg: ld a,$17
	ei:call bank01
	xor $0A
	ld (pg+1),a
	
;	ld a,(notecnt)
;	and 7:out ($FE),a

v2: ld a,0
	inc a
	ld (v2+1),a
	and 7
	push af
	xor 7
	ld l,a,h,0
	ld de,pat
	add hl,de
	ld a,(hl)
	ld l,a,h,a
	ld (spa),hl
; call pu1
 	pop af
 	or a
 	jr nz,nocopy2
 	ld hl,col+1
 	ld de,col
 	ld bc,7
 	ld a,(de)
 	ldir
 	ld (col+7),a
nocopy2:
; ld a,0:out (#FE),a
	call ous
ffpo: call ru1
; ld a,7:out (#FE),a
	jp rlp

ru1:
	ld a,(notecnt)
	cp $1E:ret nz
fpo:ld hl,$52,(ffpo+1),hl
	ret
lgo:incbin "theend.bin"
pat:
	db 255
	db %01111111;$7F;01111111
	db %00111111
	db %00011111
	db %00001111

	db %00000111
	db %00000011
	db %00000001
	db %00000000
spa: dw 0
col
;	db 7,7,7,7,7,7,7,7
	db $01,$0A,$13,$1C,$25,$2E,$37,$38

 IFNDEF rel
 include "../utils.inc"
 ELSE
 include "../demovars.inc"
 ENDIF

ous: ld (0),sp
	ld sp,col
	pop af,bc,de,hl
	ld sp,$DB00
ou:
end

 IFNDEF rel
	savesna "walkl.sna",begin
 ELSE
	savebin "07rainbow.code",begin,end-begin
 ENDIF
 
